diff --git a/lib/librte_eal/common/Makefile b/lib/librte_eal/common/Makefile
index 9effd0d45..eba1059f2 100644
--- a/lib/librte_eal/common/Makefile
+++ b/lib/librte_eal/common/Makefile
@@ -43,7 +43,7 @@ INC += rte_hexdump.h rte_devargs.h rte_bus.h rte_dev.h
 INC += rte_pci_dev_feature_defs.h rte_pci_dev_features.h
 INC += rte_malloc.h rte_keepalive.h rte_time.h
 INC += rte_service.h rte_service_component.h
-INC += rte_bitmap.h rte_vfio.h
+INC += rte_bitmap.h rte_vfio.h rte_test.h
 
 GENERIC_INC := rte_atomic.h rte_byteorder.h rte_cycles.h rte_prefetch.h
 GENERIC_INC += rte_spinlock.h rte_memcpy.h rte_cpuflags.h rte_rwlock.h
diff --git a/lib/librte_eal/common/include/rte_test.h b/lib/librte_eal/common/include/rte_test.h
new file mode 100644
index 000000000..256117f79
--- /dev/null
+++ b/lib/librte_eal/common/include/rte_test.h
@@ -0,0 +1,97 @@
+/*-
+ *   BSD LICENSE
+ *
+ *   Copyright(c) 2017 Cavium, Inc. All rights reserved.
+ *
+ *   Redistribution and use in source and binary forms, with or without
+ *   modification, are permitted provided that the following conditions
+ *   are met:
+ *
+ *	 * Redistributions of source code must retain the above copyright
+ *	   notice, this list of conditions and the following disclaimer.
+ *	 * Redistributions in binary form must reproduce the above copyright
+ *	   notice, this list of conditions and the following disclaimer in
+ *	   the documentation and/or other materials provided with the
+ *	   distribution.
+ *	 * Neither the name of Cavium, Inc nor the names of its
+ *	   contributors may be used to endorse or promote products derived
+ *	   from this software without specific prior written permission.
+ *
+ *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ *   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ *   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ *   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+ *   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ *   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+ *   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ *   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ *   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ *   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ *   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _RTE_TEST_H_
+#define _RTE_TEST_H_
+
+#include <rte_log.h>
+
+#define RTE_TEST_ASSERT(cond, msg, ...) do {                                  \
+	if (!(cond)) {                                                        \
+		RTE_LOG(DEBUG, EAL, "Test assert %s line %d failed: "         \
+				msg "\n", __func__, __LINE__, ##__VA_ARGS__); \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#define RTE_TEST_ASSERT_EQUAL(a, b, msg, ...) do {                            \
+	if (!(a == b)) {                                                      \
+		RTE_LOG(DEBUG, EAL, "Test assert %s line %d failed: "         \
+				msg "\n", __func__, __LINE__, ##__VA_ARGS__); \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#define RTE_TEST_ASSERT_NOT_EQUAL(a, b, msg, ...) do {                        \
+	if (!(a != b)) {                                                      \
+		RTE_LOG(DEBUG, EAL, "Test assert %s line %d failed: "         \
+				msg "\n", __func__, __LINE__, ##__VA_ARGS__); \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#define RTE_TEST_ASSERT_SUCCESS(val, msg, ...) do {                           \
+	typeof(val) _val = (val);                                             \
+	if (!(_val == 0)) {                                                   \
+		RTE_LOG(DEBUG, EAL,                                           \
+				"Test assert %s line %d failed (err %d): "    \
+				msg "\n", __func__, __LINE__, _val,           \
+				##__VA_ARGS__);                               \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#define RTE_TEST_ASSERT_FAIL(val, msg, ...) do {                              \
+	if (!(val != 0)) {                                                    \
+		RTE_LOG(DEBUG, EAL, "Test assert %s line %d failed: "         \
+				msg "\n", __func__, __LINE__, ##__VA_ARGS__); \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#define RTE_TEST_ASSERT_NULL(val, msg, ...) do {                              \
+	if (!(val == NULL)) {                                                 \
+		RTE_LOG(DEBUG, EAL, "Test assert %s line %d failed: "         \
+				msg "\n", __func__, __LINE__, ##__VA_ARGS__); \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#define RTE_TEST_ASSERT_NOT_NULL(val, msg, ...) do {                          \
+	if (!(val != NULL)) {                                                 \
+		RTE_LOG(DEBUG, EAL, "Test assert %s line %d failed: "         \
+				msg "\n", __func__, __LINE__, ##__VA_ARGS__); \
+		return -1;                                                    \
+	}                                                                     \
+} while (0)
+
+#endif /* _RTE_TEST_H_ */